package org.jeecg.modules.stm.plan.trance.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.stm.plan.trance.entity.StPlanTrance;
import org.jeecg.modules.stm.plan.trance.service.IStPlanTranceService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;


import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: st_plan_trance
 * @Author: jeecg-boot
 * @Date:   2023-07-16
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/plan.trance/stPlanTrance")
@Slf4j
public class StPlanTranceController extends JeecgController<StPlanTrance, IStPlanTranceService> {
	@Autowired
	private IStPlanTranceService stPlanTranceService;
	
	/**
	 * 分页列表查询
	 *
	 * @param stPlanTrance
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "st_plan_trance-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<StPlanTrance>> queryPageList(StPlanTrance stPlanTrance,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<StPlanTrance> queryWrapper = QueryGenerator.initQueryWrapper(stPlanTrance, req.getParameterMap());
		Page<StPlanTrance> page = new Page<StPlanTrance>(pageNo, pageSize);
		IPage<StPlanTrance> pageList = stPlanTranceService.page(page, queryWrapper);
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param stPlanTrance
	 * @return
	 */
	@AutoLog(value = "st_plan_trance-添加")
	  
	@RequiresPermissions("plan.trance:st_plan_trance:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody StPlanTrance stPlanTrance) {
		stPlanTranceService.save(stPlanTrance);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param stPlanTrance
	 * @return
	 */
	@AutoLog(value = "st_plan_trance-编辑")
	  
	@RequiresPermissions("plan.trance:st_plan_trance:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody StPlanTrance stPlanTrance) {
		stPlanTranceService.updateById(stPlanTrance);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "st_plan_trance-通过id删除")
	  
	@RequiresPermissions("plan.trance:st_plan_trance:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		stPlanTranceService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "st_plan_trance-批量删除")
	  
	@RequiresPermissions("plan.trance:st_plan_trance:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.stPlanTranceService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "st_plan_trance-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<StPlanTrance> queryById(@RequestParam(name="id",required=true) String id) {
		StPlanTrance stPlanTrance = stPlanTranceService.getById(id);
		if(stPlanTrance==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(stPlanTrance);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param stPlanTrance
    */
    @RequiresPermissions("plan.trance:st_plan_trance:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, StPlanTrance stPlanTrance) {
        return super.exportXls(request, stPlanTrance, StPlanTrance.class, "st_plan_trance");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("plan.trance:st_plan_trance:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, StPlanTrance.class);
    }

}
